h53497
s 00003/00002/00178
d D 1.3 82/11/12 10:50:26 ross 3 2
c Login message now comes from /etc/whoami, and is inserted
c in a much nicer way into the login: message.
e
s 00013/00001/00167
d D 1.2 82/08/23 15:19:48 cecily 2 1
c Obtain login message from the file "/etc/login" if it exists
e
s 00168/00000/00000
d D 1.1 82/08/02 15:41:08 cecily 1 0
e
u
U
t
T
I 1
/*
 * login [ name ]
 */

#include <sys/types.h>
#include <sgtty.h>
#include <utmp.h>
#include <signal.h>
#include <pwd.h>
#include <stdio.h>
#include <sys/stat.h>
#define SCPYN(a, b)	strncpy(a, b, sizeof(a))

I 2
D 3
char	loginfile[] =	"/etc/login";
E 3
I 3
char	loginfile[] =	"/etc/whoami";
E 3
char	loginmsg[64] =	"login:";

E 2
char	maildir[30] =	"/usr/spool/mail/";
struct	passwd nouser = {"", "nope"};
struct	sgttyb ttyb;
struct	utmp utmp;
char	minusnam[16] = "-";
char	homedir[64] = "HOME=";
char	*envinit[] = {homedir, "PATH=:/bin:/usr/bin", 0};
struct	passwd *pwd;

struct	passwd *getpwnam();
char	*strcat();
int	setpwent();
char	*ttyname();
char	*crypt();
char	*getpass();
char	*rindex(), *index();
extern	char **environ;

main(argc, argv)
char **argv;
{
	register char *namep;
	int t, f, c;
	char *ttyn;
I 2
	char *p;
E 2

/***/	alarm(600);
	signal(SIGQUIT, SIG_IGN);
	signal(SIGINT, SIG_IGN);
	nice(-100);
	nice(20);
	nice(0);
/*** Getty has already done this ...
	gtty(0, &ttyb);
	ttyb.sg_erase = '#';
	ttyb.sg_kill = '@';
	stty(0, &ttyb);
***/
I 2

	/* get login message from file */
	if ((t=open(loginfile, 0)) != -1) {
		for (p=loginmsg; read(t,p,1) == 1 && *p != '\n'; p++);
		*p = '\0';
I 3
		strcat(loginmsg," login: ");
E 3
		close(t);
	}

E 2
	for (t=3; t<20; t++)
		close(t);
	ttyn = ttyname(0);
	if (ttyn==0)
		ttyn = "/dev/tty??";

    loop:
	SCPYN(utmp.ut_name, "");
	if (argc>1) {
		SCPYN(utmp.ut_name, argv[1]);
		argc = 0;
	}
	while (utmp.ut_name[0] == '\0') {
		namep = utmp.ut_name;
D 2
		printf("login: ");
E 2
I 2
D 3
		printf("%s ", loginmsg);
E 3
I 3
		printf("%s", loginmsg);
E 3
E 2
		while ((c = getchar()) != '\n') {
			if(c == ' ')
				c = '_';
			if (c == EOF)
				exit(0);
			if (namep < utmp.ut_name+8)
				*namep++ = c;
		}
	}
/***	setpwent();	***/
	if ((pwd = getpwnam(utmp.ut_name)) == NULL)
		pwd = &nouser;
/***	endpwent();	***/
	if (*pwd->pw_passwd != '\0') {
		namep = crypt(getpass("Password:"),pwd->pw_passwd);
		/* if dial-up tty check if user is allowed access */
		if (strncmp(rindex(ttyn,'/'),"/ttydl",6) == 0) {
			time(&utmp.ut_time);
			if ((f=open("/usr/adm/dtmp",1)) >= 0) {
				lseek(f, 0L ,2);
				SCPYN(utmp.ut_line, index(ttyn+1, '/')+1);
				write(f, (char *)&utmp, sizeof(utmp));
				close(f);
			}
			if (*pwd->pw_gecos != 'D') {
				printf("No permission to dial-in\n");
				goto loop;
			}
		}
		if (strcmp(namep, pwd->pw_passwd)) {
			printf("Login incorrect\n");
			goto loop;
		}
	}
	if(chdir(pwd->pw_dir) < 0) {
		printf("No directory\n");
		goto loop;
	}
	time(&utmp.ut_time);
/***/	t = ttynslot(ttyn);
	if (t>0 && (f = open("/etc/utmp", 1)) >= 0) {
		lseek(f, (long)(t*sizeof(utmp)), 0);
		SCPYN(utmp.ut_line, index(ttyn+1, '/')+1);
		write(f, (char *)&utmp, sizeof(utmp));
		close(f);
	}
	if (t>0 && (f = open("/usr/adm/wtmp", 1)) >= 0) {
		lseek(f, 0L, 2);
		write(f, (char *)&utmp, sizeof(utmp));
		close(f);
	}
	chown(ttyn, pwd->pw_uid, pwd->pw_gid);
	setgid(pwd->pw_gid);
	setuid(pwd->pw_uid);
	if (*pwd->pw_shell == '\0')
		pwd->pw_shell = "/bin/sh";
	environ = envinit;
	strncat(homedir, pwd->pw_dir, sizeof(homedir)-6);
	if ((namep = rindex(pwd->pw_shell, '/')) == NULL)
		namep = pwd->pw_shell;
	else
		namep++;
	strcat(minusnam, namep);
	alarm(0);
	umask(02);
	showmotd();
	strcat(maildir, pwd->pw_name);
/***
	if(access(maildir,4)==0) {
		struct stat statb;
		stat(maildir, &statb);
***/	{	struct stat statb;
/***/		if (stat(maildir, &statb) == 0)
		if (statb.st_size)
			printf("You have mail.\n");
	}
	signal(SIGQUIT, SIG_DFL);
	signal(SIGINT, SIG_DFL);
	execlp(pwd->pw_shell, minusnam, 0);
	printf("No shell\n");
	exit(0);
}

int	stopmotd;
catch()
{
	signal(SIGINT, SIG_IGN);
	stopmotd++;
}

showmotd()
{
	FILE *mf;
	register c;

	signal(SIGINT, catch);
	if((mf = fopen("/etc/motd","r")) != NULL) {
		while((c = getc(mf)) != EOF && stopmotd == 0)
			putchar(c);
		fclose(mf);
	}
	signal(SIGINT, SIG_IGN);
}
E 1
